/* ***** BEGIN LICENSE BLOCK *****
Version: MPL 1.1/GPL 2.0/LGPL 2.1

The contents of this file are subject to the Mozilla Public License Version
1.1 (the "License"); you may not use this file except in compliance with
the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
for the specific language governing rights and limitations under the
License.

The Initial Developer of the Original Code is
Malte Kraus.

Contributor(s):

 Alternatively, the contents of this file may be used under the terms of
 either the GNU General Public License Version 2 or later (the "GPL"), or
 the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 in which case the provisions of the GPL or the LGPL are applicable instead
 of those above. If you wish to allow use of your version of this file only
 under the terms of either the GPL or the LGPL, and not to allow others to
 use your version of this file under the terms of the MPL, indicate your
 decision by deleting the provisions above and replace them with the notice
 and other provisions required by the GPL or the LGPL. If you do not delete
 the provisions above, a recipient may use your version of this file under
 the terms of any one of the MPL, the GPL or the LGPL.
***** END LICENSE BLOCK ***** */


var gFormChild = window.arguments[0];
var gTitle = window.arguments[1];
var gURI = window.arguments[2];
var gFaviconURI = window.arguments[3];
var gCharset = window.arguments[4];


function getNumericCharset(aCharset)
{
    var charset = -1;
    switch(aCharset.toUpperCase())
    {
        case "X-MAC-EXTARABIC": // 32
            charset = charset + 1;
            charset = charset + 1;
        case "X-MAC-VIETNAMESE": // 30
            charset = charset + 1;
        case "X-MAC-CENTRALEURROMAN": // 29
            charset = charset + 1;
        case "X-MAC-ETHIOPIC": // 28
            charset = charset + 1;
        case "X-MAC-MONGOLIAN": // 27
            charset = charset + 1;
        case "X-MAC-TIBETAN": // 26
            charset = charset + 1;
        case "GB2312": // 25
            charset = charset + 1;
        case "X-MAC-ARMENIAN": // 24
            charset = charset + 1;
        case "X-MAC-GEORGIAN": // 23
            charset = charset + 1;
        case "X-MAC-LAOTIAN": // 22
            charset = charset + 1;
        case "X-MAC-THAI": // 21
            charset = charset + 1;
        case "X-MAC-KHMER": // 20
            charset = charset + 1;
        case "X-MAC-BURMESE": // 19
            charset = charset + 1;
        case "X-MAC-SINHALESE": // 18
            charset = charset + 1;
        case "X-MAC-MALAYALAM": // 17
            charset = charset + 1;
        case "X-MAC-KANNADA": // 16
            charset = charset + 1;
        case "X-MAC-TELUGU": // 15
            charset = charset + 1;
        case "X-MAC-TAMIL": // 14
            charset = charset + 1;
        case "X-MAC-BENGALI": // 13
            charset = charset + 1;
        case "X-MAC-ORIYA": // 12
            charset = charset + 1;
        case "X-MAC-GUJARATI": // 11
            charset = charset + 1;
        case "X-MAC-GURMUKHI": // 10
            charset = charset + 1;
        case "X-MAC-DEVANAGARI": // 9
            charset = charset + 1;
        //case //not used:
            charset = charset + 1;
        case "X-MAC-CYRILLIC": // 7
            charset = charset + 1;
        case "X-MAC-GREEK": // 6
            charset = charset + 1;
        case "X-MAC-HEBREW": // 5
            charset = charset + 1;
        case "X-MAC-ARABIC": // 4
            charset = charset + 1;
        case "EUC-KR": // 3
            charset = charset + 1;
        case "BIG5": // 2
            charset = charset + 1;
        case "SHIFT_JIS": // 1
            charset = charset + 1;
        case "X-MAC-ROMAN": // 0
        default:
            charset = charset + 1;
    }
    return charset;
}

/* function getEncoding:
 * Tries to find the encoding of a form out.
 * Versucht, die Zeichenkodierung herauszufinden.
 */
function getEncoding(aForm)
{
    if(aForm.encoding != "")
        return aForm.encoding;
    else
        return gCharset;
}

/* function makeSearchplugin:
 * Creates the search-plugin, saves it to a file, calls the function that downloads the icon.
 * Erstellt und speichert das Search-Plugin, ruft die Funktion zum Speichern des Symbols auf.
 */
function makeSearchplugin(aName, aDescription, aURL, aFormitem)
{
    var form = aFormitem.form;
    var formElems = form.elements;

    var date = new Date();
    date = (date.getMonth() + 1) + " " + date.getDate() + ", " + date.getFullYear();

    // absolute URL of the form's action:
    try {
        var uri = Components.classes["@mozilla.org/network/io-service;1"]
                            .getService(Components.interfaces.nsIIOService)
                            .newURI(form.action, null, null);
    } catch(e) {
        var uri = Components.classes["@mozilla.org/network/io-service;1"]
                            .getService(Components.interfaces.nsIIOService)
                            .newURI(aURL, null, null).resolve(form.action);
    }
    if(uri.spec.indexOf("#") > -1)
        uri.spec = uri.spec.substring(0, uri.spec.indexOf("#"));

    var queryEncoding = getNumericCharset(getEncoding(form));
    if(queryEncoding != "")
        queryEncoding = "   queryEncoding=\"" + queryEncoding + "\"\n";

    var searchplugin = "# " + aName + " Searchplugin for Firefox/Flock/Mozilla/Netscape6+/Sherlock\n\
# automagically created by the Search Engine Ordering extension for Firefox http://maltekraus.de/Firefox/Search-Engine-Ordering/\n\
# Created at: " + date + " (MM DD, YYYY)\n\
# for " + aURL + " \n\
\n\
<SEARCH\n\
   version=\"7.1\" \n\
   name=\"" + aName + "\"\n\
   description=\"" + aDescription + "\"\n\
   method=\"GET\"\n\
   action=\"" + uri.spec + "\"\n\
   searchForm=\"" + aURL + "\"\n\
" + queryEncoding + "   queryCharset=\"" + gCharset + "\"\n\
>\n\
\n\
<input name=\"sourceid\" value=\"Mozilla-search\">\n\
";
    var newline = "\n";
    var buttons = 0;
    for(var i = 0; i < form.elements.length; i++)
    {
        if(form.elements[i].isSameNode(aFormitem))
        {
            searchplugin += "<input name=\"" + encodeURIComponent(aFormitem.name) + "\" user>\n";
        }
        else
        {
            if(form.elements[i].name == "")
                continue;

            switch(form.elements[i].type)
            {
                case "button":
                case "reset":
                {
                    break;
                }
                case "radio":
                {
                    if(form.elements[i].checked)
                        searchplugin += "<input name=\"" + encodeURIComponent(form.elements[i].name) + "\" value=\"" +
                                        encodeURIComponent(form.elements[i].value) + "\">\n";
                    break;
                }
                case "submit":
                {
                    if(buttons != 0)
                        break;

                    buttons++;
                }
                case "checkbox":
                case "hidden":
                case "text":
                case "":
                default:
                {
                    searchplugin += "<input name=\"" + encodeURIComponent(form.elements[i].name) + "\" value=\"" +
                                    encodeURIComponent(form.elements[i].value) + "\">\n";
                }
            }
        }
    }
    searchplugin += "\n</search>";

    var dir = Components.classes["@mozilla.org/file/directory_service;1"]
                         .getService(Components.interfaces.nsIProperties)
                         .get("UsrSrchPlugns", Components.interfaces.nsIFile);

    var url = Components.classes["@mozilla.org/network/io-service;1"]
                        .getService(Components.interfaces.nsIIOService)
                        .newURI(aURL, null, null);

    var file = dir.clone();
    var png  = dir.clone();
    file.append(url.host + ".src");
    png. append(url.host + ".png");

    var random;
    while(file.exists() || png.exists())
    {
        random = Math.round(Math.random() * 10000).toString();
        random = url.host + "_" + random;
        file = dir.clone();
        png =  dir.clone();
        file.append(random + ".src");
        png. append(random + ".png");
    }

    file.create(file.NORMAL_FILE_TYPE, 0664); // prevent a Bug (?) in Frefox 1.5

    // searchplugins do not support unicode
    // only some special encodings for western/japanese/whatever chars
    // so until I can come up with a encoding-detection
    // only ASCII-charactes will be allowed
    searchplugin = searchplugin.replace(/[^\w\d\!\"\#\$\%\&\'\(\)\*\,\-\.\/\:\;\<\=\>\?\@\[\\\]\^\`\{\}\~\ \f\n\r\t\v]/g, "");

    // write to the actual searchplugin (*.src)
    var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                             .createInstance(Components.interfaces.nsIFileOutputStream);

    foStream.init(file, 0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
    foStream.write(searchplugin, searchplugin.length);
    foStream.close();

    // the following code would save the Plugin as Unicode
    // but Search-Plugins can only use some non-unicode Encodings :-(
    /*var fos = Components.classes["@mozilla.org/network/file-output-stream;1"]
                        .createInstance(Components.interfaces.nsIFileOutputStream);
    fos.init(file, 0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate

    var charset = "UTF-8";
    var os = Components.classes["@mozilla.org/intl/converter-output-stream;1"]
                       .createInstance(Components.interfaces.nsIConverterOutputStream);
    os.init(fos, charset, 4096, "?".charCodeAt(0));
    os.writeString(searchplugin);
    os.close();

    fos.close();*/
    // end writing the searchplugin

    // download the icon and save it as *.png even if it is another format (Fx searches only for *.png, *.gif and *.jp(e)g)
    var icon = document.getElementById("icon");
    var iconFile = dir.clone();
    iconFile.append(file.leafName.replace(/\.src$/, ".png"));

    if(icon.file && icon.file.exists())
        icon.file.copyTo(dir, iconFile.leafName);
    else
        saveURI(icon.src, iconFile);

    var fileProtocolHandler = Components.classes["@mozilla.org/network/protocol;1?name=file"]
                                        .getService(Components.interfaces.nsIFileProtocolHandler);
    var iconURI = fileProtocolHandler.getURLSpecFromFile(icon.file && icon.file.exists() ? icon.file : iconFile);

    return {src:file.path, icon:iconURI};
}

/* function saveURI:
 * Downloads a File with the URI aURI to the file aTargetFile.
 * Lädt die Datei aURI herunter und speichert sie in die Datei aTargetFile.
 */
function saveURI(aURI, aTargetFile)
{
    var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                              .getService(Components.interfaces.nsIIOService);
    var URI = ioService.newURI(aURI, null, null);

    try
    {
        var webBrowserPersist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowser;1"]
                                          .createInstance(Components.interfaces.nsIWebBrowserPersist);
        webBrowserPersist.persistFlags = webBrowserPersist.PERSIST_FLAGS_FROM_CACHE;
        webBrowserPersist.saveURI(URI, null, null, null, null, aTargetFile);
        return aTargetFile;
    }
    catch(e)
    {
        var appLocale = Components.classes["@mozilla.org/intl/nslocaleservice;1"]
                        .getService(Components.interfaces.nsILocaleService)
                        .getApplicationLocale();
        var strings = Components.classes["@mozilla.org/intl/stringbundle;1"]
                      .getService(Components.interfaces.nsIStringBundleService)
                      .createBundle("chrome://searchengineordering/locale/create.properties", appLocale);

        alert(strings.formatStringFromName("failed", aTargetFile.path, 1));
        return false;
    }
}

/* Function onDialogAccept:
 * Calls the function to create and save the search-plugin, to download the icon; informs other windows by adding a pref.
 * Ruft die Funktionen zum Erstellen und Speichern des Search-Plugins und zum Herunterladen das Symbol auf, schreibt eine Einstellung um andere Fenster zu aktualisieren.
 */
function onDialogAccept(aEvent)
{
    var name = document.getElementById("name").value;
    var description = name;
    var obj = makeSearchplugin(name, description, gURI, gFormChild);

    // manually inform all open windows and all windows that will be opened of this new engine
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                          .getService(Components.interfaces.nsIPrefService)
                          .getBranch("extensions.searchengineordering.");
    var newPlugins = prefs.getComplexValue("create.newengines", Components.interfaces.nsISupportsString).data;
    var newEngines = Components.classes["@mozilla.org/supports-string;1"]
                               .createInstance(Components.interfaces.nsISupportsString);
    newEngines.data = (newPlugins == "" ? "" : newPlugins + "|") + encodeURIComponent("engine://" + encodeURIComponent(obj.src)) + "^" + encodeURIComponent(obj.icon) + "^" + encodeURIComponent(name);
    prefs.setComplexValue("create.newengines", Components.interfaces.nsISupportsString, newEngines);

    return true;
}
/* Function onDOMContentLoaded:
 * Loads the default values from the window's arguments.
 * Lädt die an den Dialog übergebenen Standard-Werte.
 */
function onDOMContentLoaded(aEvent)
{
    document.getElementById("name").value = gTitle.replace(/[^\w\d\!\#\$\%\&\'\(\)\*\,\-\.\/\:\;\<\=\>\?\@\[\\\]\^\`\{\}\~\ \f\n\r\t\v]/g, "?");
    document.getElementById("name").addEventListener("input", function() { this.value = this.value.replace(/[^\w\d\!\#\$\%\&\'\(\)\*\,\-\.\/\:\;\<\=\>\?\@\[\\\]\^\`\{\}\~\ \f\n\r\t\v]/g, ""); }, false);
    document.getElementById("icon").src = gFaviconURI;

    sizeToContent();
    resizeTo(outerWidth + innerWidth, outerHeight); // doubles the width of the window
}

window.addEventListener("DOMContentLoaded", onDOMContentLoaded, false);

/* Function pickIcon:
 * Displays a Filepicker to change the icon of the searchplugin.
 * Zeigt einen Dateiauswahl-Dialog, um das Symbol wechseln zu können.
 */
function pickIcon(aEvent)
{
    try
    {
        const nsIFilePicker = Components.interfaces.nsIFilePicker;

        var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                              .getService(Components.interfaces.nsIPrefService)
                              .getBranch("extensions.searchengineordering.");

        var icon = document.getElementById("icon");

        var fp = Components.classes["@mozilla.org/filepicker;1"]
	                       .createInstance(nsIFilePicker);
        fp.init(window, "", nsIFilePicker.modeOpen);
        fp.appendFilters(nsIFilePicker.filterAll | nsIFilePicker.filterImages);
        fp.filterIndex = 1;
        try
        {
            fp.displayDirectory = prefs.getComplexValue("create.lastdir", Components.interfaces.nsILocalFile);
            if(!fp.displayDirectory)
                throw "pref not set";
        }
        catch(e)
        {
            fp.displayDirectory = Components.classes["@mozilla.org/file/directory_service;1"]
                                            .getService(Components.interfaces.nsIProperties)
                                            .get("UsrSrchPlugns", Components.interfaces.nsIFile);
        }
        if(typeof icon.file != "undefined")
        {
            if(icon.file.parent.exists())
                fp.displayDirectory = icon.file.parent;
            if(icon.file.exists())
                fp.defaultString = icon.file.leafName;
        }

        var rv = fp.show();
        if(rv == nsIFilePicker.returnOK)
        {
            var file = fp.file;
            if(!file.exists() || !file.isReadable() || file.isDirectory())
                return;

            prefs.setComplexValue("create.lastdir", Components.interfaces.nsILocalFile, file.parent);

            var uriConverter = Components.classes["@mozilla.org/network/protocol;1?name=file"]
                                         .createInstance(Components.interfaces.nsIFileProtocolHandler);
            var fileURI = uriConverter.getURLSpecFromFile(file);

            icon.src = fileURI;
            icon.file = file;
        }
    }
    catch(e)
    {
        return;
    }
}
